using System;
using System.Configuration;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Data.Odbc;
using System.IO;
using System.Xml;

namespace Stoermeldungen.Class
{
	/// <summary>
	/// Hier werden die Datenbankoperationen durchgefhrt.
    /// 3.09.2008, Eigentum von S&K 
    /// </summary>
	public class DataConnection
	{
		public static string sErrorText="";

        /// <summary>
        /// Holen des DB Connectionstrings
        /// </summary>
        /// <returns></returns>
        public static System.Configuration.ConnectionStringSettings holeConnectionString()
        {
            System.Configuration.Configuration rootWebConfig =
                System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/Stoermeldungen");
            System.Configuration.ConnectionStringSettings connString = new ConnectionStringSettings();
            if (0 < rootWebConfig.ConnectionStrings.ConnectionStrings.Count)
            {
                connString =
                    rootWebConfig.ConnectionStrings.ConnectionStrings["stoer_rpcConnectionString"];                
            }
            return connString;
        }
        
        /// <summary>
        /// Holen des Connectionstring fr die Excel Datei.
        /// 
        /// </summary>
        /// <returns></returns>
        public static System.Configuration.ConnectionStringSettings holeConnectionStringExcel()
        {
            System.Configuration.Configuration rootWebConfig =
                System.Web.Configuration.WebConfigurationManager.OpenWebConfiguration("/Stoermeldungen");
            System.Configuration.ConnectionStringSettings connString = new ConnectionStringSettings();
            if (0 < rootWebConfig.ConnectionStrings.ConnectionStrings.Count)
            {
                connString =
                    rootWebConfig.ConnectionStrings.ConnectionStrings["StoermeldeTexteExcelConnection"];                
            }
            return connString;
        }

		public static DataTable ExecuteQuery(string sSql)
		{
			SqlCommand _command = new SqlCommand(sSql);
			return(ExecuteQuery(_command));
		}

		public static DataTable ExecuteQuery(SqlCommand Command)
		{
			SqlConnection _conn = null;
			SqlDataAdapter _adapter = null;
			DataTable dt = null;
			try
			{
				_conn = new SqlConnection(holeConnectionString().ToString());
				DataSet Ds = new DataSet();
				_conn.Open();
				Command.Connection = _conn;
				_adapter = new SqlDataAdapter(Command);
				_adapter.Fill(Ds);
				dt = Ds.Tables["Table"];
			}
			catch(Exception excpt)
			{sErrorText=excpt.Message.ToString();	}
			finally
			{
				_conn.Close();
			}
			return(dt);
		}

		public static int ExecuteNonQuery(string sSql)
		{
			SqlCommand _command = new SqlCommand(sSql);
			return(ExecuteNonQuery(_command));
		}

		public static int ExecuteNonQuery(SqlCommand Command)
		{
			SqlConnection _conn = null;
			int iRowsAffected = 0;
			try
			{
				_conn = new SqlConnection(holeConnectionString().ToString());
				_conn.Open();

				//DB-Sprache wird auf "deutsch" gesetzt (wegen Datumskonvertierung)
				SqlCommand Sprache = new SqlCommand("SET Language GERMAN",_conn);
				Sprache.ExecuteNonQuery();
				Command.Connection = _conn;
				iRowsAffected = Command.ExecuteNonQuery();
				return(iRowsAffected);
			}
			catch(Exception ex)
			{
                sErrorText = ex.Message;
			}
			finally
			{
				_conn.Close();
			}
			return(iRowsAffected);
		}

        public static DataTable ExecuteQueryExcel(string sSql)
        {

            OdbcCommand _command = new OdbcCommand(sSql);
            return (ExecuteQueryExcel(_command));
        }
        public static DataTable ExecuteQueryExcel(OdbcCommand Command)
        {

            OdbcConnection _conn = null;

            OdbcDataAdapter _adapter = null;
            DataTable dt = null;
            try
            {
                _conn = new OdbcConnection(holeConnectionStringExcel().ToString());
                DataSet Ds = new DataSet();
                _conn.Open();
                Command.Connection = _conn;
                _adapter = new OdbcDataAdapter(Command);
                _adapter.Fill(Ds);
                dt = Ds.Tables["Table"];
            }
            catch (Exception excpt)
            { sErrorText = excpt.Message.ToString(); }
            finally
            {
                _conn.Close();
            }
            return (dt);
        }
    }
}
