﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
//using System.Data;
using System.Data.SqlClient;
using Stoermeldungen.Class;

namespace Stoermeldungen
{
    /// <summary>
    /// Seite für Anzeige von alten Störungen
    /// </summary>
    public partial class StoerHistorie : PageBase
    {
        protected static int iRows = 0;
        protected static int iAktRows = 0;

        /// <summary>
        /// Wegen der Filterung ist es nötig, der DB Anbindung immer die aktuelle
        /// SQL Abfrage zuzuweisen.
        /// </summary>
        protected string CurrentSQLCommand
        {
            get
            {
                string sReturn = string.Empty;
                object oReturn = Session["CurrentSQLCommand"];
                if (oReturn != null)
                {
                    sReturn = oReturn.ToString();
                    
                }
                if (oReturn == null || sReturn == string.Empty)
                {
                    Session["CurrentSQLCommand"] = stoer_rpc_db.SelectCommand;
                    sReturn = stoer_rpc_db.SelectCommand;
                    OriginalSQLCommand = sReturn;
                }
                   
                return sReturn;
            }
            set
            {
                Session["CurrentSQLCommand"] = value;
            }
        }

        /// <summary>
        /// Sicherung der Original Abfrage
        /// </summary>
        protected string OriginalSQLCommand
        {
            get
            {
                string sReturn = string.Empty;
                object oReturn = Session["OriginalSQLCommand"];
                if (oReturn != null)
                {
                    sReturn = oReturn.ToString();

                }
                else               
                    Session["OriginalSQLCommand"] = sReturn = "";
                return sReturn;
            }
            set
            {
                Session["OriginalSQLCommand"] = value;
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                BindDDL();
                BindData();
                setTitle(Page.Title);
           
            }
            else if(uwg_HistStör.IsXmlHttpRequest == false)           
                stoer_rpc_db.SelectCommand = CurrentSQLCommand; //Ansonsten vergisst ASP.NET es
        }

        protected void EventInfo_Click(object sender, EventArgs e)
        {
            ShowInfo();          
        }

        protected void BindDDL()
        { 
            try
            {
                ddl_Anlage.Items.Clear();
                ddl_Anlage.Items.Add(new ListItem("*** alle Anlagen ***","-1"));

                string sSql = "SELECT anlagen_bez, Anlagen_ID FROM T_anlagen ORDER BY anlagen_bez";
                SqlCommand CmdEquipment = new SqlCommand(sSql);
                DataTable dt = DataConnection.ExecuteQuery(CmdEquipment);
                if(dt == null)
                    return;
                foreach(DataRow theRow in dt.Rows)
                     ddl_Anlage.Items.Add(new ListItem(theRow["anlagen_bez"].ToString(),theRow["Anlagen_ID"].ToString()));
            }
            catch
            {}
        }
        /// <summary>
        /// Anzeige, ob die maximale Grenze für die angezeigte Datenmenge erreicht ist.
        /// </summary>
        /// <param name="iRowCount">Die Anzahl der Zeilen</param>
        protected void updateDatenStatus(int iRowCount)
        {
            if (iRowCount >= 1000)
            {
                lb_DatenStatus.Text = "1000 Datensätze erreicht. Bitte beschränken Sie die Suche per Filter ein!";
                lb_DatenStatus.ForeColor = System.Drawing.Color.Red;
            }
            else
            {
                lb_DatenStatus.Text = "Es werden " + iRowCount.ToString() + " Datensätze angezeigt.";
                lb_DatenStatus.ForeColor = System.Drawing.Color.Black;
            }           
        }

        protected void BindData()
        { BindData(false); }
        
        /// <summary>
        /// Daten Binden
        /// </summary>
        /// <param name="bSearch">Sollen die Suchkriterien berücksichtigt werden?</param>
        protected void BindData(bool bSearch)
        {
            string sSqlWhere = string.Empty;
            if(bSearch)
            {
                if(CurrentSQLCommand != string.Empty && OriginalSQLCommand != string.Empty)
                    stoer_rpc_db.SelectCommand = OriginalSQLCommand;

                //Anlagen ID
                if(ddl_Anlage.SelectedValue != "-1")
                {
                    if(sSqlWhere == string.Empty)
                        sSqlWhere += " WHERE ";
                    else
                        sSqlWhere += " AND ";
                    sSqlWhere += "T_historische_Stoerungen.anlagen_ID = '" +
                        ddl_Anlage.SelectedValue + "'";
                }

                //Fehlernummer
                int iNrVon = -1;
                int iNrBis = -1;
                if(tb_NrVon.Text != "")
                {
                    try
                    {
                        iNrVon = Convert.ToInt32(tb_NrVon.Text);
                    }
                    catch
                    {
                        ShowMessage(tb_NrVon.Text + " ist kein gültige Nummer! Bitte geben Sie eine gültige Zahl ein!");
                        return;
                    }
                }
                if(tb_NrBis.Text != "")
                {
                    if(iNrVon < 0)
                    {
                        ShowMessage("Ein BIS Fehlercode ist nur erlaubt, wenn ein VON Fehlercode definiert wurde!");
                        return;
                    }
                    try
                    {
                        iNrBis = Convert.ToInt32(tb_NrBis.Text);
                    }
                    catch
                    {
                        ShowMessage(tb_NrBis.Text + " ist kein gültige Nummer! Bitte geben Sie eine gültige Zahl ein!");
                        return;
                    }
                    if(iNrBis < iNrVon)
                    {
                        ShowMessage(tb_NrBis.Text + " ist größer als" + tb_NrVon.Text + "! Bitte korrigieren Sie die Reihenfolge!");
                        return;
                    }
                }
                if(iNrVon > -1)
                {
                    if(sSqlWhere == string.Empty)
                        sSqlWhere += " WHERE ";
                    else
                        sSqlWhere += " AND ";
                    if(iNrBis < 0)
                        sSqlWhere += "T_historische_Stoerungen.Fehlernr = " + iNrVon.ToString();
                    else
                        sSqlWhere += "(T_historische_Stoerungen.Fehlernr BETWEEN " + iNrVon.ToString() + " AND " + iNrBis.ToString() + ")";

                }

                //Datum
                DateTime DateFrom = NotDefinedDate.Date;
                DateTime DateTill = NotDefinedDate.Date;
                if(WebDateFrom.Value != null)
                    DateFrom = (DateTime)WebDateFrom.Value;
                if(WebDateTill.Value != null)
                {
                    if(DateFrom == NotDefinedDate.Date)
                    {
                        ShowMessage("Ein BIS Datum ist nur erlaubt, wenn ein VON Datum definiert wurde!");
                        return;
                    }
                    DateTill = (DateTime)WebDateTill.Value;
                }
                if(DateFrom != NotDefinedDate.Date)
                {
                    if(sSqlWhere == string.Empty)
                        sSqlWhere += " WHERE ";
                    else
                        sSqlWhere += " AND ";
                    if(DateTill != NotDefinedDate.Date)
                    {
                        if(DateFrom > DateTill)
                        {
                            ShowMessage(DateFrom.ToString() + " liegt hinter " + DateTill.ToString() + "! Bitte korrigieren Sie die Reihenfolge!");
                            return;
                        }
                    }
                    else
                    {
                        DateTill = DateFrom.AddDays(1);
                    }
                    sSqlWhere += "kommen_datum BETWEEN '" + DateFrom.ToString(NotDefinedDate.DateFormatForSelect) + "' AND '" + DateTill.ToString(NotDefinedDate.DateFormatForSelect) + "'";

                }
                int iOrderIndex = stoer_rpc_db.SelectCommand.IndexOf("ORDER BY");
                if(iOrderIndex != -1)
                    stoer_rpc_db.SelectCommand = stoer_rpc_db.SelectCommand.Substring(0,iOrderIndex);
                stoer_rpc_db.SelectCommand += sSqlWhere + " ORDER BY kommen_datum DESC";
                CurrentSQLCommand = stoer_rpc_db.SelectCommand;                
                //Scheint nicht nötig zu sein
                //stoer_rpc_db.DataBind();
            }
            //else
            //{
            //    stoer_rpc_db.SelectCommand +=" ORDER BY kommen_datum DESC";                
            //}
        }

        protected void stoer_rpc_db_Selected(object sender, SqlDataSourceStatusEventArgs e)
        {
            //Die einzig gute Stelle, um beim Paging an die Gesamtanzahl der Zeilen zu kommen.
            updateDatenStatus(e.AffectedRows);
        }

        protected void bu_Filter_Click(object sender, EventArgs e)
        {
            BindData(true);

        }

        protected void Bu_DateVonClear_Click(object sender, EventArgs e)
        {
            WebDateFrom.Value = null;
         
        }

        protected void Bu_DateBisClear_Click(object sender, EventArgs e)
        {
            WebDateTill.Value = null;
        }

        private void ExportGrid()
        {
            ShowMessage("Function removed");
        }

        protected void bu_Excel_Export_Click(object sender, EventArgs e)
        {
            ExportGrid();
        }

        protected void bu_Drucken_Click(object sender, EventArgs e)
        {
            ExportGrid();
        }

        protected void bu_PDF_Export_Click(object sender, EventArgs e)
        {
            ExportGrid();

        }

        protected void gv_HistStör_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void gv_HistStör_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            //stoer_rpc_db.SelectCommand = CurrentSQLCommand;
            //gv_HistStör.PageIndex = e.NewPageIndex;

            

        }

        protected void uwg_HistStör_InitializeRow(object sender, Infragistics.WebUI.UltraWebGrid.RowEventArgs e)
        {
            //Status Hilfstext vorhanden
            switch(e.Row.Cells[0].Text)
            {
                case "0":
                    e.Row.Cells[0].Text = "";
                    break;
                case "1":
                    e.Row.Cells[0].Text = "?";
                    e.Row.Cells[0].Style.ForeColor = System.Drawing.Color.Red;
                    e.Row.Cells[0].Style.Font.Size = FontUnit.Larger;
                    e.Row.Cells[0].Style.Font.Bold = true;
                    break;
                default:
                    break;
            }
        }

        protected void uwg_HistStör_DblClick(object sender, Infragistics.WebUI.UltraWebGrid.ClickEventArgs e)
        {
            lb_DatenStatus.Text = iAktRows.ToString();
            //ShowInfo();            
        }       

        protected void uwg_HistStör_SortColumn(object sender, Infragistics.WebUI.UltraWebGrid.SortColumnEventArgs e)
        {
            //stoer_rpc_db.SelectCommand = CurrentSQLCommand; //Ansonsten vergisst ASP.NET es
        }

        protected void ShowInfo()
        {
            if(uwg_HistStör.DisplayLayout.ActiveRow == null)
            {
                ShowMessage("Keine Störung ausgewählt!");
            }
            else
            {
                //StoerDaten StoerID = new StoerDaten();
                //StoerID.sAktFehlerNr = SelFehlerNr;
                //StoerID.AnlagenName = SelAnlagenName;
                //StoerID.AnlagenID = SelAnlagenID;
                //StoerID.Gekommen = SelGekommen;
                //StoerID.BMK = SelBMK;
                //StoerID.FehlerText = SelFehlerText;
                //Session["StoerID"] = StoerID;
                //ChangePage("StoerungsListe.aspx");
            }
        }

        string SelFehlerNr
        {
            get
            {
                return hf_FehlerNr.Value;//uwg_HistStör.DisplayLayout.ActiveRow.Cells[2].Text;
            }
        }

        string SelAnlagenName
        {
            get
            {
                return hf_AnlagenName.Value;//uwg_HistStör.DisplayLayout.ActiveRow.Cells[1].Text;
            }
        }

        int SelAnlagenID
        {
            get
            {
                return Convert.ToInt32(hf_AnlagenID.Value); //uwg_HistStör.DisplayLayout.ActiveRow.Cells[8].Text
            }
        }

        DateTime SelGekommen
        {
            get
            {   
                //DateTime Gekommen = new DateTime();
                
                return DateTime.Parse(hf_Gekommen.Value);//uwg_HistStör.DisplayLayout.ActiveRow.Cells[5].Text
            }
        }

        string SelBMK
        {
            get
            {
                return hf_BMK.Value;//uwg_HistStör.DisplayLayout.ActiveRow.Cells[3].Text;
            }
        }

        string SelFehlerText
        {
            get
            {
                return Server.HtmlDecode(hf_Fehlertext.Value);//uwg_HistStör.DisplayLayout.ActiveRow.Cells[4].Text
            }
        }

        protected void uwg_HistStör_InitializeDataSource(object sender, Infragistics.WebUI.UltraWebGrid.UltraGridEventArgs e)
        {
            //uwg_HistStör.DataSource = stoer_rpc_db.Select(DataSourceSelectArguments.Empty);
            //uwg_HistStör.DataSourceID = stoer_rpc_db.UniqueID;
            uwg_HistStör.DataBind();

            
        }

        protected void uwg_HistStör_InitializeLayout(object sender, Infragistics.WebUI.UltraWebGrid.LayoutEventArgs e)
        {
            //uwg_HistStör.Bands[0].DataKeyField ="T_historische_Stoerungen.Anlagen_id, T_historische_Stoerungen.Fehlernr,T_historische_Stoerungen.Kommen_datum";
            uwg_HistStör.Bands[0].DataKeyField = "Anlagen_id,Fehlernr,Kommen_datum";                  
        }

        protected void uwg_HistStör_XmlHTTPRequest(object sender, Infragistics.WebUI.UltraWebGrid.XmlHTTPRequestEventArgs e)
        {
            iAktRows++;
            //uwg_HistStör.OnXmlHTTPRequest(

        }       
    }
}
    